Contributing Guidelines
=======================

Setup
-----

1. [Fork the project][how-to-fork] and clone the fork to your machine.
2. Create a feature branch to work in. `$ git checkout -b name-of-feature`

Writing Code
------------

* Use the project's coding style, not your own. If the code you write looks drastically different than the preexisting code, you're doing it wrong.
* Include tests that fail without your code, and pass with it.
* Commits should have meaningful messages. If you end up with a bunch of commits with garbage messages, squash your commits before submitting a pull request.

Pull Requests
-------------

1. Push your feature branch to your remote repo on GitHub. `$ git push origin name-of-feature`
2. [Create a pull request][create-pull-request] against master.
3. Write a meaningful title and description. If you've added a new feature or break backwards compatibility, let us know so we can updated the docs accordingly.
5. Submit the pull request!

[how-to-fork]: https://help.github.com/articles/fork-a-repo
[create-pull-request]: https://help.github.com/articles/creating-a-pull-request

License
-------

By contributing your code,

You agree to license your contribution under the terms of the MIT License
https://github.com/twitter/typeahead.js/blob/master/LICENSE
